<template>
  <el-dialog
    class="modify-system-notice"
    :visible.sync="modalIsShow"
    :title="title"
    top="10vh"
    width="600px"
    :close-on-click-modal="false"
    :close-on-press-escape="false"
    append-to-body
    @open="visibleChange"
  >
    <el-form
      ref="modalFormComp"
      :model="modalForm"
      :rules="rules"
      label-width="80px"
    >
      <el-form-item prop="title" label="标题：">
        <el-input
          v-model.trim="modalForm.title"
          placeholder="请输入标题"
          clearable
        ></el-input>
      </el-form-item>
      <el-form-item prop="content" label="内容：">
        <el-input
          v-model.trim="modalForm.content"
          placeholder="请输入内容"
          type="textarea"
          maxlength="999"
          :autosize="{ minRows: 4, maxRows: 10 }"
          show-word-limit
        ></el-input>
      </el-form-item>
      <el-form-item label="状态：">
        <el-radio v-model="modalForm.enable" :label="true">启用</el-radio>
        <el-radio v-model="modalForm.enable" :label="false">禁用</el-radio>
      </el-form-item>
    </el-form>
    <div slot="footer">
      <el-button type="primary" :disabled="isSubmit" @click="submit"
        >确认</el-button
      >
      <el-button @click="cancel">取消</el-button>
    </div>
  </el-dialog>
</template>

<script>
import { objAssign } from "@/utils/utils";
import { saveSystemNotice } from "@/api/system";

const initModalForm = {
  id: null,
  title: "",
  content: "",
  enable: true,
};

export default {
  name: "ModifySystemNotice",
  props: {
    instance: {
      type: Object,
      default() {
        return {};
      },
    },
  },
  computed: {
    isEdit() {
      return !!this.instance.id;
    },
    title() {
      return (this.isEdit ? "编辑" : "新增") + "系统通知";
    },
  },
  data() {
    return {
      modalIsShow: false,
      isSubmit: false,
      modalForm: { ...initModalForm },
      rules: {
        title: [
          {
            required: true,
            message: "请输入标题",
            trigger: "change",
          },
          {
            message: "标题不能超过100个字",
            max: 100,
            trigger: "change",
          },
        ],
        content: [
          {
            required: true,
            message: "请输入内容",
            trigger: "change",
          },
        ],
      },
    };
  },
  methods: {
    initData(val) {
      if (val.id) {
        this.modalForm = objAssign(initModalForm, val);
      } else {
        this.modalForm = { ...initModalForm };
      }
    },
    visibleChange() {
      this.initData(this.instance);
    },
    cancel() {
      this.modalIsShow = false;
    },
    open() {
      this.modalIsShow = true;
    },
    async submit() {
      const valid = await this.$refs.modalFormComp.validate().catch(() => {});
      if (!valid) return;

      if (this.isSubmit) return;
      this.isSubmit = true;
      let datas = { ...this.modalForm };
      const data = await saveSystemNotice(datas).catch(() => {});
      this.isSubmit = false;

      if (!data) return;

      this.$message.success(this.title + "成功！");
      this.$emit("modified");
      this.cancel();
    },
  },
};
</script>
